Attribute VB_Name = "ModAss"

Public OpArg(787) As OpArg
Public Equ_val() As Long, Equ_word() As String, Equ_Assigned() As Boolean
Public iLabelID As Integer
Public OpcodeError As Boolean
Public ASMcnt As Long
Public Org_ASM As Long
Public Rescan As Integer
Public LinesArray() As String, Lines_PC() As Long

Type Byte16
    B1 As Byte
    B2 As Byte
    Num As Byte
End Type

Type OpArg
    InStr As String * 5
    ARGS As String * 9
    OP1 As Byte
    OP2 As Byte
    BYTES As Byte
    RULE As String * 4
    Class As Byte
    SHIFT As Boolean
    OR1 As Byte
    OR2 As Byte
    NBOp As Integer
End Type

Dim bLngByte As Boolean



Sub Get_Lines(text As String, LinesArray() As String, Optional Rc As Integer)

Dim line_Cnt As Long, Ca As Integer, cB As Integer, cC As Integer, LabelId As Integer
Dim TmpVal As String
Dim MyHexChr As String
Dim MyHexChr2 As String
Dim TmpText As String, TmpText2 As String
Dim sLabel As String
Dim sLLine As String
Dim Str1 As String, Str2 As String
Dim DbType As String

Dim sVal1 As String, sVal2 As String

ReDim LinesArray(0)

text = Trim(Remove_Tabs(text)) & vbCrLf

line_Cnt = 0

Do
LOffset = InStr(1, text, vbCrLf, vbBinaryCompare)

If LOffset = 0 Then
    ReDim Preserve LinesArray(line_Cnt)
    LinesArray(line_Cnt) = Trim(text)
    Exit Do
End If

ReDim Preserve LinesArray(line_Cnt)

LinesArray(line_Cnt) = Trim(Left(text, LOffset - 1))

If InStr(1, LinesArray(line_Cnt), "DB ") = 0 And InStr(1, LinesArray(line_Cnt), "db ") = 0 _
And InStr(1, LinesArray(line_Cnt), "@") <> 1 Then
    LinesArray(line_Cnt) = UCase(LinesArray(line_Cnt))
End If

If InStr(1, LinesArray(line_Cnt), ";") Then LinesArray(line_Cnt) = Left(LinesArray(line_Cnt), InStr(1, LinesArray(line_Cnt), ";") - 1)


    If LinesArray(line_Cnt) = "" Or Left(text, 1) = ";" Or Left(text, 1) = "#" Then
    line_Cnt = line_Cnt - 1
    Else
    
        If InStr(1, LinesArray(line_Cnt), "EQU") Then
            sLabel = Trim(Left(LinesArray(line_Cnt), InStr(1, LinesArray(line_Cnt), "EQU") - 1))
            
            If InStr(1, sLabel, ":") > 0 Then Mid(sLabel, InStr(1, sLabel, ":"), 1) = " "
            If InStr(1, sLabel, ".") > 0 Then Mid(sLabel, InStr(1, sLabel, "."), 1) = " "
            sLabel = Trim(sLabel)
            
  
            If InStr(1, sLabel, ":") > 0 Then sLabel = Mid(sLabel, InStr(1, sLabel, ":") - 1)
            AddLabel (sLabel)
            

            If Equ_Assigned(iLabelID - 1) = False Then
                Equ_val(iLabelID - 1) = GetVal(Trim(Mid(LinesArray(line_Cnt), InStr(1, LinesArray(line_Cnt), "EQU") + 3)))
                Equ_Assigned(iLabelID - 1) = True
            End If
            
            line_Cnt = line_Cnt - 1
    
        Else
            If InStr(1, LinesArray(line_Cnt), ":") > 0 And InStr(1, LinesArray(line_Cnt), "DB ") = 0 And InStr(1, LinesArray(line_Cnt), "db ") = 0 Then
                LinesArray(line_Cnt) = "@" & Trim(Left(text, InStr(1, LinesArray(line_Cnt), ":")))

                LOffset = InStr(1, text, ":")
                sLabel = Trim(Left(text, InStr(1, text, ":") - 1))
                If IsLabel(sLabel) = -1 Then
                    AddLabel (sLabel)
                'LOffset = InStr(1, text, ":")
                'line_Cnt = line_Cnt + 1
                End If
            Else
                           ' LinesArray(line_Cnt) = "@" & Trim(text)
            End If
        End If
    

      If line_Cnt > -1 Then

' DB function

If InStr(1, UCase(LinesArray(line_Cnt)), ".DB") Or InStr(1, UCase(LinesArray(line_Cnt)), ".DW") Or _
InStr(1, UCase(LinesArray(line_Cnt)), ".DS") Or InStr(1, UCase(LinesArray(line_Cnt)), "DB ") Or _
InStr(1, UCase(LinesArray(line_Cnt)), "DW ") Or InStr(1, UCase(LinesArray(line_Cnt)), "DS ") Then
        
        If InStr(1, UCase(LinesArray(line_Cnt)), "DB") Then DbType = "DB"
        If InStr(1, UCase(LinesArray(line_Cnt)), "DW") Then DbType = "DW"
        If InStr(1, LinesArray(line_Cnt), ";") Then LinesArray(line_Cnt) = Trim(Left(LinesArray(line_Cnt), InStr(1, LinesArray(line_Cnt), ";") - 1))
        TmpText = Trim(Mid(LinesArray(line_Cnt), InStr(1, LinesArray(line_Cnt), " ") + 1))
        
          
RescanValues:

'Get the next value
            If InStr(1, TmpText, ",") > 0 Then
            TmpText2 = Trim(Left(TmpText, InStr(1, TmpText, ",") - 1))
            TmpText = Mid(TmpText, InStr(1, TmpText, ",") + 1)
            Else
            TmpText2 = Trim(TmpText)
            TmpText = ""
            End If
            
            Debug.Print IsLabel(TmpText2)
            
             If (InStr(1, TmpText2, Chr(34)) > 0 Or InStr(1, TmpText2, "'") > 0) And IsLabel(TmpText2) = -1 Then
            AddLabel (TmpText2)
            End If
            
             Debug.Print IsLabel(TmpText2)
             
 If InStr(1, TmpText2, "$") = 0 And InStr(1, UCase(TmpText2), "&H") = 0 Then

       If IsLabel(TmpText2) > -1 Then
            If InStr(1, TmpText2, """") = 0 Then
                If Enum_Exp(TmpText2) > 255 And DbType = "DB" And Rc = 1 Then
                Form1.ErrLog.text = Form1.ErrLog.text & "Label 16 Bits error [" & TmpText2 & "@>" & LinesArray(line_Cnt) & "] used with '.DB'" & vbCrLf
                End If
            End If
            
            If DbType = "DB" Then
            LinesArray(line_Cnt) = ".DB &h" & Hex8(Equ_val(IsLabel(TmpText2)))
            Else
            LinesArray(line_Cnt) = ".DW &h" & Hex16(Equ_val(IsLabel(TmpText2)))
            End If
            
           
            line_Cnt = line_Cnt + 1
            ReDim Preserve LinesArray(line_Cnt)
            
      Else  'DEC

                If Not IsAssNum(TmpText2) And Rc = 1 And Not IsExp(TmpText2) And InStr(1, TmpText2, """") = 0 And InStr(1, TmpText2, "'") = 0 Then
                Form1.ErrLog.text = Form1.ErrLog.text & "Label error [" & TmpText2 & "@>" & LinesArray(line_Cnt) & "] not set." & vbCrLf
                End If
             
             
            If DbType = "DB" Then
                        
            If IsBinary(TmpText2) Then
             LinesArray(line_Cnt) = ".DB &h" & Hex8(BinToDbl(TmpText2))
             Else
            LinesArray(line_Cnt) = ".DB &h" & Hex8(Enum_Exp(TmpText2))
            End If
            
            Else
            LinesArray(line_Cnt) = ".DW &h" & Hex16(Enum_Exp(TmpText2))
            End If
            
            line_Cnt = line_Cnt + 1
            ReDim Preserve LinesArray(line_Cnt)
      End If
     
 End If

 If InStr(1, TmpText2, "$") > 0 Or InStr(1, TmpText2, "H") > 0 Then

        
        TmpText2 = Trim(TmpText2)
            
            If DbType = "DB" Then
            LinesArray(line_Cnt) = ".DB &h" & Hex8(GetVal(TmpText2))
            Else
            Debug.Print Enum_Exp(TmpText2)
            LinesArray(line_Cnt) = ".DW &h" & Hex16(GetVal(Enum_Exp(TmpText2)))
            End If
            
            line_Cnt = line_Cnt + 1
            ReDim Preserve LinesArray(line_Cnt)
            
           ' If InStr(1, TmpText, ",") > 0 Then TmpText = Trim(Mid(TmpText, InStr(1, TmpText, ",") + 1))
            
 End If

            If TmpText <> "" Then GoTo RescanValues: GoTo DbExit
            
DolExit:
             line_Cnt = line_Cnt - 1
        

End If ' DB function
      
' Fill funtion
        If InStr(1, LinesArray(line_Cnt), ".FILL") > 0 Or InStr(1, LinesArray(line_Cnt), "FILL") = 1 Then
          sVal1 = Mid( _
          LinesArray(line_Cnt), _
          InStr(1, LinesArray(line_Cnt), "(") + 1, _
          InStr(1, LinesArray(line_Cnt), ",") - InStr(1, LinesArray(line_Cnt), "(") - 1 _
          )
          
          sVal2 = Mid( _
          LinesArray(line_Cnt), _
          InStr(1, LinesArray(line_Cnt), ",") + 1, _
          InStr(1, LinesArray(line_Cnt), ")") - InStr(1, LinesArray(line_Cnt), ",") - 1 _
          )
          For line_Cnt = line_Cnt To line_Cnt + CLng(sVal1) - 1
          ReDim Preserve LinesArray(line_Cnt)
          
          LinesArray(line_Cnt) = ".DB " & "&h" & Hex8(Val16(sVal2))
          
          Next
          line_Cnt = line_Cnt - 1
        End If
         If InStr(1, LinesArray(line_Cnt), "END") > 0 Then
         LinesArray(line_Cnt) = ""
         End If
    End If
End If

DbExit:
text = Right(text, Len(text) - LOffset)


Do While Left(text, 1) = " " Or Left(text, 1) = vbTab Or Left(text, 1) = vbLf
 text = Right(text, Len(text) - 1)
Loop



If line_Cnt >= 0 Then
If InStr(LinesArray(line_Cnt), ";") <> 0 Then LinesArray(line_Cnt) = Trim(Left(LinesArray(line_Cnt), InStr(LinesArray(line_Cnt), ";") - 1))
End If

line_Cnt = line_Cnt + 1
Loop

For Ca = 0 To line_Cnt
    If line_Cnt <> 0 Then
    
    For cB = 0 To UBound(Equ_word)
   If InStr(1, LinesArray(Ca), Equ_word(cB)) > 0 Then
        TmpVal = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), Equ_word(cB)))
                 If InStr(1, TmpVal, ")") > 0 Then TmpVal = Left(TmpVal, InStr(1, TmpVal, ")") - 1)
                 If InStr(1, TmpVal, ",") > 0 Then TmpVal = Left(TmpVal, InStr(1, TmpVal, ",") - 1)
                ' If InStr(1, TmpVal, "+") > 0 Then TmpVal = Left(TmpVal, InStr(1, TmpVal, "+") - 1)
                ' If InStr(1, TmpVal, "-") > 0 Then TmpVal = Left(TmpVal, InStr(1, TmpVal, "-") - 1)
                ' If InStr(1, TmpVal, "/") > 0 Then TmpVal = Left(TmpVal, InStr(1, TmpVal, "/") - 1)
            
            If IsExp(TmpVal) Then Exit For
            
            If Equ_word(cB) = Trim(TmpVal) Then
                If Equ_Assigned(cB) Then
                 If Equ_val(cB) > 255 Then
                         LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), Equ_word(cB)) - 1) & "&h" & Hex16(Equ_val(cB)) & Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), Equ_word(cB)) + Len(Equ_word(cB)))
                         Exit For
                 Else
                         If InStr(LinesArray(line_Cnt), "@") > 0 Then
                         LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), Equ_word(cB)) - 1) & "&h" & Hex8(Equ_val(cB))
                         Exit For
                         End If
                 End If
                End If
             End If
      
    End If
    TmpVal = ""
    Next cB
    
    End If
    
    If InStr(1, LinesArray(Ca), "$") Then
    
    TmpText = LinesArray(Ca)
    
    MyHexChr = UCase(Mid(TmpText, InStr(1, TmpText, "$")))

    
    sLLine = ""
    If InStr(1, LinesArray(Ca), "$") < InStr(LinesArray(Ca), ",") Then sLLine = Mid(LinesArray(Ca), InStr(LinesArray(Ca), ","))
    If InStr(1, LinesArray(Ca), "$") < InStr(LinesArray(Ca), "),") Then sLLine = Mid(LinesArray(Ca), InStr(LinesArray(Ca), "),"))
  
    If InStr(LinesArray(Ca), ",(") Then sLLine = ")"
  
    If InStr(1, sLLine, ";") > 0 Then sLLine = Left(sLLine, InStr(sLLine, ";") - 1)
    
    
    LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), "$") - 1)
    
Debug.Print Enum_Exp(MyHexChr)
    
            If Enum_Exp(MyHexChr) > 255 Then
                LinesArray(Ca) = LinesArray(Ca) & "&h" & Hex16(Enum_Exp(MyHexChr)) & sLLine
               Else
                LinesArray(Ca) = LinesArray(Ca) & "&h" & Hex8(Enum_Exp(MyHexChr)) & sLLine
            End If
    Else


If InStr(1, LinesArray(Ca), "IX+") > 0 Or InStr(1, LinesArray(Ca), "IY+") > 0 Then
If InStr(1, LinesArray(Ca), "IX") > 0 Then
         TmpVal = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), "IX") + 3)
         TmpVal = Left(TmpVal, InStr(1, TmpVal, ")") - 1)
         Str1 = Mid(LinesArray(Ca), 1, InStr(1, LinesArray(Ca), "IX") + 2)
         Str2 = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), ")"))
         
                If IsDecValue(TmpVal) Then
                    LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                Else
                ' Numeric values or labels.
                    If IsExp(TmpVal) Then
                          LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                     Else
                     '     AddLabel (TmpVal)
                     
                          If Val(Enum_Exp(TmpVal)) < 0 Then
                          LinesArray(Ca) = Str1 & "&h" & Hex$(256 + Val(Enum_Exp(TmpVal))) & Str2
                          Else
                          LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                          End If
                    End If

                End If
        
         
Else
         TmpVal = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), "IY") + 3)
         TmpVal = Left(TmpVal, InStr(1, TmpVal, ")") - 1)
         Str1 = Mid(LinesArray(Ca), 1, InStr(1, LinesArray(Ca), "IY") + 2)
         Str2 = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), ")"))
         
                If IsDecValue(TmpVal) Then
                    LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                Else
                ' Numeric values or labels.
                    If IsExp(TmpVal) Then
                          LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                     Else
                     '     AddLabel (TmpVal)
                     
                          If Val(Enum_Exp(TmpVal)) < 0 Then
                          LinesArray(Ca) = Str1 & "&h" & Hex$(256 + Val(Enum_Exp(TmpVal))) & Str2
                          Else
                          LinesArray(Ca) = Str1 & "&h" & Hex$(Val(Enum_Exp(TmpVal))) & Str2
                          End If
                    End If

                End If
End If
End If


    
      If InStr(1, LinesArray(Ca), ",") = 0 Then ' "," cases
    ' No "," char.
    
    If InStr(1, LinesArray(Ca), "IX") = 0 And InStr(1, LinesArray(Ca), "IY") = 0 Then
    
    If Left(LinesArray(Ca), 4) = "AND " Or _
       Left(LinesArray(Ca), 5) = "CALL " Or _
       Left(LinesArray(Ca), 3) = "CP " Or _
       Left(LinesArray(Ca), 2) = "OR" Or _
       Left(LinesArray(Ca), 4) = "SUB " Or _
       Left(LinesArray(Ca), 4) = "TST " Or _
       Left(LinesArray(Ca), 6) = "TSTIO " Or _
       Left(LinesArray(Ca), 4) = "XOR " _
    Then
    
    TmpVal = Trim(Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), " ") + 1))
    
    If IsReg(TmpVal) = 0 Then

      If IsLabel(TmpVal) > -1 Then
      If Enum_Exp(TmpVal) >= 0 Or IsLabel(TmpVal) > -1 Then
       LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), " ")) & "&h" & Hex$(Val16(Enum_Exp(TmpVal)))
      Else
       LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), " ")) & "&h" & Hex$(256 + Val16(Enum_Exp(TmpVal)))
      End If
      
      
      Else
      
      
                    ' Numeric values or labels.
                If IsExp(TmpVal) Or IsLabel(TmpVal) > -1 Then
                      LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), " ")) & "&h" & Hex$(Val16(Enum_Exp(TmpVal)))
                Else
                      LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), " ")) & "&h" & Hex$(Val16(TmpVal))
                End If
      
      
      End If
      
      
      
      
    End If
    End If
    End If ' IX/IY
    
    Else
    
    '",*" argument.
    If Left(LinesArray(Ca), 3) = "ADC" Or _
         Left(LinesArray(Ca), 4) = "ADD " Or _
         Left(LinesArray(Ca), 3) = "JP " Or _
         Left(LinesArray(Ca), 3) = "LD " Or _
         Left(LinesArray(Ca), 4) = "SBC " _
    Then
      TmpVal = Mid(LinesArray(Ca), InStr(1, LinesArray(Ca), ",") + 1)
      If IsReg(TmpVal) = 0 And InStr(1, TmpVal, "IX") = 0 And InStr(1, TmpVal, "IY") = 0 Then
      

                    If InStr(1, TmpVal, "(") = 0 Then ' Not incirect
                            If IsLabel(TmpVal) > -1 Then
                            LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), ",")) & "&h" & Hex$((Equ_val(IsLabel(TmpVal))))
                            Else
                            
                    
                                    If IsDecValue(TmpVal) Then
                                          LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), ",")) & "&h" & Hex$(Enum_Exp(TmpVal))
                                    Else
                                        ' Numeric values or labels.
                                        If IsExp(TmpVal) Or IsLabel(TmpVal) > -1 Then
                                              LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), ",")) & "&h" & Hex$(Val16(Enum_Exp(TmpVal)))
                                        Else
                                              AddLabel (TmpVal)
                                        End If
                    
                                    End If
                            End If
                                    
                    Else ' Incirect value (****)
                              TmpVal = Trim(TmpVal)
                              Mid(TmpVal, InStr(1, TmpVal, "("), 1) = " "
                              Mid(TmpVal, InStr(1, TmpVal, ")"), 1) = " "
                              TmpVal = Trim(TmpVal)
                              
                                    If IsDecValue(TmpVal) Then
                                          LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), ",")) & "(&h" & Hex$(Enum_Exp(TmpVal)) & ")"
                                    Else
                                        ' Numeric values or labels.
                                        If IsExp(TmpVal) Or IsLabel(TmpVal) > -1 Then
                                              LinesArray(Ca) = Left(LinesArray(Ca), InStr(1, LinesArray(Ca), ",")) & "(&h" & Hex$(Val16(Enum_Exp(TmpVal))) & ")"
                                        Else
                                              AddLabel (TmpVal)
                                        End If
                    
                                    End If
                    End If

          

      End If
      
    End If
    
    End If ' "," cases
    
    End If
    
NextArg:
Next Ca

End Sub

Sub Assemble()

On Error GoTo Main_Err

Dim App_path As String
App_path = App.Path

Dim MyText As String
Dim NbLine As Long, fnc As String, Fnc1 As String, Fnc2 As String, GetASM As String
Dim Sub1 As String, Sub2 As String
Dim FrstChr As String * 1
Dim MnemValue1 As Long, MnemValue2 As Long
Dim AsmBuffer() As Byte
Dim Result1 As OpArg
Dim Result As Byte16

Dim LabelsArray()

Dim DirectASM() As Byte
Dim f1 As Integer
Dim RetUnStr As Integer
Dim CurLine As String
Dim bCommand As Boolean
Dim iLabelID As Integer
Dim Label As String, Label2 As String
Dim LabID As Integer
Dim Fnc2bis As String, sLabel As String
Dim Decay As Long
Dim TmpByte As Byte
Dim bByte As Byte
Dim IxIy As Byte
Dim DBtag As String
Dim Ca As Integer
Dim sTMPval As String

ASMcnt = 0

ReDim Equ_word(0): ReDim Equ_val(0): ReDim Equ_Assigned(0)

Form1.ErrLog.text = ""
Form1.ListView2.ListItems.Clear

Org_ASM = 16514



For Rescan = 0 To 1

ReDim LinesArray(0)
ReDim AsmBuffer(0)
 
MyText = Form1.Text1.text


Get_Lines MyText, LinesArray(), Rescan

Form1.ListView1.ListItems.Clear
For Ca = 0 To UBound(LinesArray) - 1
'MyText = MyText & LinesArray(Ca) & vbCrLf
Form1.ListView1.ListItems.Add Ca + 1, , Ca + 1
Form1.ListView1.ListItems.Item(Form1.ListView1.ListItems.Count).SubItems(1) = LinesArray(Ca)
Next

'Debug.Print Len(MyText)


DoEvents

' Get "Org" function.
Do While NbLine <= UBound(LinesArray)

If InStr(1, UCase(LinesArray(NbLine)), "ORG ") <> 0 Then
    
    If InStr(1, LinesArray(NbLine), "&h") = 0 Then
    ' decimal numeric value.
    Org_ASM = Val16(Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, LinesArray(NbLine), "+")))
    Else
    ' Hexadecimal numeric value.
    Org_ASM = Val16(Trim(Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, UCase(LinesArray(NbLine)), "ORG") - 2)))
    End If
    Exit Do
End If

NbLine = NbLine + 1
Loop

NbLine = 0: iLabelID = 0

Do While NbLine <= UBound(LinesArray) ' Loop Line reading

Label = ""
Label2 = ""
Fnc1 = ""
Fnc2 = ""
Sub1 = ""
Sub2 = ""

 ReDim Preserve Lines_PC(NbLine)
 Lines_PC(NbLine) = ASMcnt + Org_ASM

'Mirror the current line to get directs
' ASM values, if the mnemonics test is corrupt.
CurLine = Trim(UCase(LinesArray(NbLine)))

FrstChr = LinesArray(NbLine)
Select Case FrstChr
    Case "@"
' Get label.
' ASM2 label: xxxx = yyyy
    If InStr(1, LinesArray(NbLine), "=") = 0 Then
            nxtpar = InStr(1, LinesArray(NbLine), " ")
                If nxtpar <= 1 Then
                    Label = Mid(LinesArray(NbLine), 2, Len(LinesArray(NbLine)) - 2)
                    LinesArray(NbLine) = ""
                     Else
                    Label = Left(LinesArray(NbLine), nxtpar - 1)
                    LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, LinesArray(NbLine), " "))
                End If

' TASM label: xxxx .equ yyyy
    Else
             nxtpar = InStr(1, LinesArray(NbLine), "=")
                If nxtpar <= 1 Then
                    Label = LinesArray(NbLine)
                    LinesArray(NbLine) = ""
    
                    Else
                    Label = Left(LinesArray(NbLine), nxtpar - 1)
                    LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
                End If
                
                nxtpar = InStr(1, LinesArray(NbLine), " ")
                If nxtpar <= 1 Then
                    Label2 = LinesArray(NbLine)
                    LinesArray(NbLine) = ""
                     Else
                    Label2 = Left(LinesArray(NbLine), nxtpar - 1)
                    LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
                End If
  
    End If
    
    Case ";"
            'Remarque.
            GoTo Nscan:
            
    Case "."
            
        'GoTo PutByte
        
    
     
End Select

If InStr(1, CurLine, ".DB") > 0 Or InStr(1, CurLine, ".DW") > 0 Then
    DBtag = Left(LinesArray(NbLine), InStr(1, CurLine, " ") - 1)
        Select Case DBtag
        Case ".DB", ".DW", "DB", "DW"
        sTMPval = Trim(Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - 3))

                    ReDim Preserve AsmBuffer(ASMcnt)
                    AsmBuffer(ASMcnt) = CByte(Val16(sTMPval) And 255)
                    ASMcnt = ASMcnt + 1
            
            If DBtag = ".DW" Or DBtag = "DW" Then
                    ReDim Preserve AsmBuffer(ASMcnt)
                    AsmBuffer(ASMcnt) = CByte(Val16(sTMPval) \ 256)
                    ASMcnt = ASMcnt + 1
            End If
            GoTo Nxt_line
       End Select
End If


If Label <> "" And Rescan = 0 Then
        LabelId = IsLabel(Label)
        If LabelId <> -1 And InStr(1, CurLine, "@") > 0 Then
                Equ_val(LabelId) = Org_ASM + ASMcnt
                Equ_Assigned(LabelId) = True
        End If

End If


' -------------------------------------------

If LinesArray(NbLine) = "" Or Left(LinesArray(NbLine), 1) = ";" Or Left(LinesArray(NbLine), 1) = "." Then GoTo Nscan

' -------------------------------------------

nxtpar = InStr(1, LinesArray(NbLine), " ")

    If nxtpar <= 1 Then
        Fnc1 = LinesArray(NbLine)
        LinesArray(NbLine) = ""
        Fnc2 = ""
        Else
        Fnc1 = Left(LinesArray(NbLine), nxtpar - 1)
        'LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
    End If


'If Fnc1 <> "JP" And Fnc1 <> "JR" Then
'    Fnc2 = Remove_Spaces(LinesArray(NbLine))
'Else
    nxtpar = InStr(1, LinesArray(NbLine), " ")
        If nxtpar <> 0 Then
        Fnc2 = Trim(Mid(LinesArray(NbLine), nxtpar + 1))
        Else
        Fnc2 = "" 'Value
        End If
'End If

nxtpar = InStr(1, Fnc2, ";")

If nxtpar > 1 Then Fnc2 = Left(Fnc2, nxtpar - 1)

Nscan:

Fnc2bis = Fnc2

If InStr(1, UCase(Fnc1), "ORG ") > 0 Or (Fnc1 = "" And Fnc2 = "") Then GoTo Nxt_line

'Test Function argument.
'String.
FrstChr = Fnc2
If FrstChr = Chr(34) Or FrstChr = "'" Then
    Fnc2 = Right(Fnc2, Len(Fnc2) - 1)
    nxtpar = InStr(1, Fnc2, FrstChr)
    Fnc2 = Left(Fnc2, nxtpar - 1)

      FrstChr = Fnc2
            
      MnemValue1 = ASCIICharToZX(FrstChr)
      Fnc2 = "*"
End If

MnemValue1 = 0
MnemValue2 = 0
vallen = 0

' Get sub-mnemonics.
nxtpar = InStr(1, Fnc2, ",")
' Is there any vigule.

Sub1 = Fnc2: Sub2 = ""
If nxtpar > 1 Then
Sub1 = Left(Fnc2, nxtpar - 1)
Sub2 = Right(Fnc2, Len(Fnc2) - nxtpar)


    
    If Len(Sub1) <> 0 And IsReg(Sub1) = 0 Then
    
    If Fnc1 = "JR" Then Fnc2bis = Sub1
    If Fnc1 = "DJNZ" Then Fnc2bis = Sub1

        If FrstChr = "(" Then
        FrstChr = Sub1
        Sub1 = Right(Fnc2, Len(Fnc2) - 1)
        nxtpar = InStr(1, Sub1, ")")
        If nxtpar <> 0 Then Sub1 = Left(Sub1, nxtpar - 1)
        
                If InStr(1, Sub1, "IX") <> 0 Or InStr(1, Sub1, "IY") <> 0 Then
                ' IX - xx or IY - xx

                Label = Mid(Sub1, InStr(1, Sub1, "+") + 1)
                Label2 = Cut_Alfa_Label(Label)
                
                        If IsLabel(Label2) <> -1 Then
                             IxIy = Equ_val(IsLabel(Label2)) + Val16(Mid(Label, InStr(1, Label, "+") + 1))
                        Else
                             IxIy = Mid(Sub1, InStr(1, Sub1, "+") + 1)
                       End If
               '---------------------------------------------------------------------
              
               
                If InStr(1, Sub1, "IX") <> 0 Then Sub1 = "(IX*)"
                If InStr(1, Sub1, "IY") <> 0 Then Sub1 = "(IY*)"
                FrstChr = Sub1
                
                Else
 
                FrstChr = Sub1
                End If
                
         If IsReg(Sub1) = 0 Then
           
           If FrstChr <> "&" Then
               'NOT HEXA
               MnemValue1 = Val16(Enum_Exp(Sub1))
        
              Else
               ' HEXA
               MnemValue1 = Val16(Enum_Exp(Sub1))
             '  If IsHexValue(Sub1) Then
             '   MnemValue1 = ASChex(Sub1)
            '   End If
              ' Sub1 = "*"
              End If
              
         vallen = 2
         If Fnc1 = "OUT" Then vallen = 1
     
         If Sub1 <> "(IX*)" And Sub1 <> "(IY*)" Then Sub1 = "(*)"
         
         End If
         
        Else
        
        FrstChr = Sub1
        If FrstChr <> "&" Then
                    If IsReg(Sub1) = 0 Then
                     MnemValue1 = Val16(Enum_Exp(Sub1))
                     If Fnc1 = "BIT" Or Fnc1 = "RES" Or Fnc1 = "SET" Then Else Sub1 = "*"
                    End If
          Else
              
                MnemValue1 = Val16(Enum_Exp(Sub1))
                     If Len(Sub1) > 4 Then vallen = 2 Else vallen = 1
                     Sub1 = "*"

          
        If Sub1 = "BC" Or Sub1 = "HL" Or Sub1 = "DE" Or Sub1 = "SP" Then vallen = 2 Else vallen = 1: Sub1 = "*"
        
        End If

        End If
    End If
        
  If Len(Sub2) > 0 And IsReg(Sub2) = 0 Then
  
      If Fnc1 = "JR" Then Fnc2bis = Sub2
      
        FrstChr = Sub2
    If FrstChr = "(" Then
        Sub2 = Right(Sub2, Len(Sub2) - 1)
        nxtpar = InStr(1, Sub2, ")")
        If nxtpar <> 0 Then Sub2 = Left(Sub2, nxtpar - 1)
        
                If InStr(1, Sub2, "IX") <> 0 Or InStr(1, Sub2, "IY") <> 0 Then
                ' IX - xx or IY - xx
                Label = Mid(Sub2, InStr(1, Sub2, "+") + 1)


                        If IsLabel(Label) <> -1 Then
                             IxIy = Equ_val(IsLabel(Label))

                        Else
                            If Val(Mid(Sub2, InStr(1, Sub2, "+") + 1)) < 0 Then
                                IxIy = CByte(256 + Val(Mid(Sub2, InStr(1, Sub2, "+") + 1)))
                            Else
                                IxIy = CByte(Mid(Sub2, InStr(1, Sub2, "+") + 1))
                            End If
                        End If
                        
                   If InStr(1, Sub2, "IX") <> 0 Then Sub2 = "(IX*)"
                   If InStr(1, Sub2, "IY") <> 0 Then Sub2 = "(IY*)"
                   FrstChr = Sub2
                Else
 
                FrstChr = Sub2
                End If
        
        If Sub2 <> "HL" And Sub2 <> "BC" And Sub2 <> "DE" And _
           Sub2 <> "SP" And Sub2 <> "IX*" And Sub2 <> "IY*" And _
           Sub2 <> "(HL)" And Sub2 <> "(BC)" And Sub2 <> "(DE)" And _
           Sub2 <> "(SP)" And Sub2 <> "(IX*)" And Sub2 <> "(IY*)" _
           Then
            If FrstChr <> "&" Then
            ' Dec value
             MnemValue2 = Val16(Enum_Exp(Sub2))
            Else
            ' Hex value
             MnemValue2 = Val16(Enum_Exp(Sub2))
            End If
            
          Sub2 = "(*)"

        End If

     Else
     
       FrstChr = Sub2
       If FrstChr <> "&" Then
       
               MnemValue2 = Val16(Enum_Exp(Sub2))
               Sub2 = "*"
               
        Else
                      If InStr(1, Sub2, "&") Then
                           MnemValue2 = Val16(Sub2)
                           If Len(Sub2) > 4 Then vallen = 2 Else vallen = 1
                           Sub2 = "*"

                         If MnemValue2 = 188 Then Sub2 = "BC"
                         If MnemValue2 = 222 Then Sub2 = "DE"

                      Else
                           Debug.Print "Erreur HEXA"
                      End If
                      
                      If Sub1 = "(*)" Then
                         If MnemValue2 = 188 Then Sub2 = "BC"
                         If MnemValue2 = 222 Then Sub2 = "DE"
                      Else
                        If Len(Sub2) > 4 Then vallen = 2 Else vallen = 1
                         Sub2 = "*"
                      End If
          End If
        

        End If
    End If
        Fnc2 = Sub1 & "," & Sub2
Else

' Only one argument SUB1: Fnc1="CALL" Fnc2="$1234"



                                If IsLabel(Sub1) > -1 Then
                                     MnemValue2 = Equ_val(IsLabel(Sub1))
                                     MnemValue1 = MnemValue2
                                     Sub1 = "*": Fnc2 = "*"
                                     If Fnc1 = "IM" Then Sub1 = "": Fnc2 = MnemValue2
                                Else
                                    If Sub1 <> "" And InStr(1, Sub1, "IX") = 0 And InStr(1, Sub1, "IY") = 0 Then
                                    Debug.Print IsReg(Sub1)
                                      If IsReg(Sub1) = 0 Then
                                      MnemValue2 = Val16(Enum_Exp(Sub1))
                                       MnemValue1 = MnemValue2
                                        Sub1 = "*": Fnc2 = "*"
                                       If Fnc1 = "IM" Then Sub1 = "": Fnc2 = MnemValue2
                                       End If
                                    End If
                                End If
                    'End If

End If


' CALL --------------------------------------
If Left(Fnc2, 1) <> "@" And _
    InStr(1, Fnc2, "IX") = 0 And _
    InStr(1, Fnc2, "IY") = 0 Then
    
    If InStr(1, Fnc2, ",") > 0 Then
    ' Nothing to do.
    Else
    
        If InStr(1, UCase(Fnc2), "&H") > 0 Then
                                If Len(Fnc2) > 4 Then vallen = 2 Else vallen = 1
                                 MnemValue2 = Val16(Fnc2)
                                 Sub2 = "*"
                                 Fnc2 = "*"
        Else
                                
                 If IsReg(Sub2) = 0 Then
                                If IsLabel(Sub2) > -1 Then
                                     MnemValue2 = Equ_val(IsLabel(Fnc2))
                                     MnemValue1 = MnemValue2
                                     Sub2 = "*"
                                     'Fnc2 = "*"
                                Else
                                    If Sub2 <> "" Then
    
                                      '  If Val(Fnc2) > 255 Then vallen = 2 Else vallen = 1
                                       MnemValue2 = Val16(Enum_Exp(Sub2))
                                       MnemValue1 = MnemValue2
                                        Sub2 = "*"
                                     '   Sub1 = "(*)"
                                     '   Fnc2 = Sub2
                                    End If
                                End If
                    End If

    End If
    End If
    
 Else ' without "," symbol.
 

  
  If InStr(1, Fnc2, ",") = 0 And IsReg(Fnc2) = 0 Then
  
  
  'IX.IY : ADD (IX+xx) without "," symbol.
       If InStr(1, Fnc2, "IX") <> 0 Or InStr(1, Fnc2, "IY") <> 0 Then
                       Label = Mid(Fnc2, InStr(1, Fnc2, "+") + 1)
                       Label = Left(Label, Len(Label) - 1)
                       
                        If IsLabel(Label) <> -1 Then
                             IxIy = Equ_val(IsLabel(Label))
                        Else
                            If Val16(Label) < 0 Then
                                IxIy = CByte(256 + Val16(Label))
                            Else
                                IxIy = CByte(Label)
                            End If
                        End If
       
       
        If InStr(1, Fnc2, "IX") <> 0 Then Fnc2 = "(IX*)": Sub1 = "(IX*)"
        If InStr(1, Fnc2, "IY") <> 0 Then Fnc2 = "(IY*)": Sub1 = "(IY*)"
       End If
   End If

End If

If Fnc1 = "BIT" Or Fnc1 = "RES" Or Fnc1 = "SET" Then
If Fnc2 = "*" Then GoTo exitif

    If IsDecValue(Trim(Mid(Fnc2, 1, InStr(1, Fnc2, ",") - 1))) Then
        bByte = Val16(Trim(Mid(Fnc2, 1, InStr(1, Fnc2, ",") - 1)))
        
         Fnc2 = "*" & Mid(Fnc2, InStr(1, Fnc2, ","))
        
    If InStr(1, Fnc2, "IX") > 0 Then Fnc2 = "*,(IX*)"
    If InStr(1, Fnc2, "IY") > 0 Then Fnc2 = "*,(IY*)"
            
    Else

    ' TODO:
    ' RES|A,*,(IX*)|CBDD|4|ZBIT|1|0|8700
     bByte = Val16(Mid(Fnc2, InStr(1, Fnc2, ","), InStr(InStr(1, Fnc2, ","), Fnc2, ",") - InStr(1, Fnc2, ",")))
    
     If IsReg(Mid(Fnc2, InStr(1, Fnc2, ",") + 1)) = 0 And InStr(1, Fnc2, "(IX*)") = 0 And InStr(1, Fnc2, "(IY*)") = 0 Then
     Fnc2 = Left(Fnc2, InStr(1, Fnc2, ",")) & "*" & Mid(Fnc2, InStr(1, Fnc2, ",") + 1)
     End If
    
    End If
    

End If

exitif:

If Fnc1 = "RST" And Fnc2 = "*" Then Fnc2 = IIf(MnemValue1 < 10, "0", "") & MnemValue1 & "H"

' -------------------------------------------

If Fnc1 = "ORG" Then GoTo Nxt_line


Result1.OP2 = 0
Result1.OP1 = 0
OpcodeError = True
Result1 = GetAsmCodes(Fnc1, Fnc2)

Debug.Print Fnc1, Fnc2, Result1.OP1, Result1.OP2, OpcodeError



If OpcodeError Then
GoTo OpErr
End If

If Result1.NBOp > 1 Then
    If Result1.OP1 <> 211 Then
            TmpByte = Result1.OP2
            Result1.OP2 = Result1.OP1
            Result1.OP1 = TmpByte
    End If
End If



'If IsLabel(Trim(Label)) And Rescan = 0 Then
'Debug.Print Label
'End If



' RES BIT SET...
If Trim(Result1.RULE) = "ZBIT" Or Trim(Result1.RULE) = "ZIX" Then
                 If Sub2 = "(IX*)" Or Sub2 = "(IY*)" Or Sub1 = "(IX*)" Or Sub1 = "(IY*)" Then
                    Result1.OR1 = (Result1.OR1) + (bByte * 8)
                    Else
                    Result1.OP2 = (Result1.OP2) + (bByte * 8)
                End If
                bByte = 0
End If





Result.B1 = Result1.OP1
If Result1.NBOp > 1 Then Result.B2 = Result1.OP2

If Result.B1 <> 0 And Fnc1 <> "NOP" Then
'     Debug.Print Fnc1; "-"; Hex16(CLng(Result.B1) * 256 + CLng(Result.B2)); ": Ok!"
Else

' Assemble as is. (hex value or dec value.
' Rescan the line and add in the asm codes.

If CurLine <> "" And InStr(1, CurLine, "ORG ") = 0 Then
 If InStr(1, CurLine, ";") = 1 Then GoTo Nxt_line
    
    If InStr(1, CurLine, ";") > 0 Then CurLine = Trim(Left(CurLine, InStr(1, CurLine, ";") - 1))
    
    RetUnStr = -1
    RetUnStr = Unstring(CurLine, DirectASM())
        If RetUnStr = -1 Then GoTo Nxt_line
                For f1 = 0 To RetUnStr
                    ReDim Preserve AsmBuffer(ASMcnt)
                    AsmBuffer(ASMcnt) = DirectASM(f1)
                    ASMcnt = ASMcnt + 1
                Next f1
        End If
        GoTo Nxt_line
    End If

PutByte:
ReDim Preserve AsmBuffer(ASMcnt)

AsmBuffer(ASMcnt) = Result.B1
ASMcnt = ASMcnt + 1


If Result1.NBOp > 1 Or bLngByte Then
        ReDim Preserve AsmBuffer(ASMcnt)
        AsmBuffer(ASMcnt) = Result.B2
        ASMcnt = ASMcnt + 1
End If

If bLngByte Then: LngByte = False: GoTo Nxt_line:


' Relative jump
If Trim(Result1.RULE) = "R1" And Rescan = 1 Then

            'If LinesArray(NbLine) <> "" Then Fnc2bis = LinesArray(NbLine)
            If InStr(1, Fnc2bis, "&") > 0 Then
              Decay = (Enum_Exp(Fnc2bis) - (Org_ASM + ASMcnt))
              If Decay > 127 Then Form1.ErrLog.text = Form1.ErrLog.text & "Relative jump error: " & LinesArray(NbLine) & vbCrLf
              If Decay <= -127 Then Form1.ErrLog.text = Form1.ErrLog.text & "Relative jump error: " & LinesArray(NbLine) & vbCrLf
                   
                   If Decay < 0 Then
                    Decay = 255 + Decay
                    Else
                    Decay = Decay - 1
                    End If
            Else
            LabID = -1
                If Fnc2bis <> "" Then
                           
                        LabID = IsLabel(Fnc2bis)
                        If LabID > -1 Then
                       ' Debug.Print Fnc2bis, Equ_word(LabID), Enum_Exp(Fnc2bis), Equ_val(10)
                              Decay = (Enum_Exp(Fnc2bis)) - (Org_ASM + ASMcnt)
                              
                                                
                                If Decay > 127 Then Form1.ErrLog.text = Form1.ErrLog.text & "Relative jump error: " & LinesArray(NbLine) & vbCrLf
                                If Decay <= -127 Then Form1.ErrLog.text = Form1.ErrLog.text & "Relative jump error: " & LinesArray(NbLine) & vbCrLf

                              If Decay < 0 Then
                              Decay = 255 - Abs(Decay)
                              Else
                              Decay = Decay - 1
                              End If
                            
                        End If
                End If
            End If
            
            
            MnemValue1 = Decay
            Sub1 = "*"
            Sub2 = ""
           
End If



NbValbytes = Result1.BYTES - Result1.NBOp
If NbValbytes <> 0 Then
        If NbValbytes > 0 Then
        
        '
        'xx:
        '
             ReDim Preserve AsmBuffer(ASMcnt)
                 If Sub1 = "*" Or Sub1 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue1 And 255)
                 If Sub2 = "*" Or Sub2 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue2 And 255)
                 If Sub2 = "(IX*)" Or Sub2 = "(IY*)" Or Sub1 = "(IX*)" Or Sub1 = "(IY*)" Then AsmBuffer(ASMcnt) = CByte(IxIy And 255)
             ASMcnt = ASMcnt + 1
        End If

        If NbValbytes = 2 Then
        ReDim Preserve AsmBuffer(ASMcnt)
                 If Sub1 = "*" Or Sub1 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue1 \ 256)
                 
                 If Sub2 = "*" Or Sub2 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue2 \ 256)
                 
                 If Sub2 = "(IX*)" Or Sub2 = "(IY*)" Or Sub1 = "(IX*)" Or Sub1 = "(IY*)" Then AsmBuffer(ASMcnt) = Result1.OR1
                 If Sub1 = "(IX*)" Or Sub1 = "(IY*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue2 And 255)
                 If (Sub1 = "(IX*)" Or Sub1 = "(IY*)") And Trim(Result1.RULE) = "ZIX" _
                 And Sub2 = "" Then AsmBuffer(ASMcnt) = Result1.OR1
                 
                
            ASMcnt = ASMcnt + 1
        End If
        
        
        
   '     If NbValbytes = 2 And Result1.BYTES = 4 Then
   '     ReDim Preserve AsmBuffer(ASMcnt + 2)
                  
   '               AsmBuffer(ASMcnt) = Result1.OR2 + 0
   '               AsmBuffer(ASMcnt + 1) = Result1.OR1
                  'CByte(MnemValue2 \ 256)
  '          ASMcnt = ASMcnt + 2
    '    End If
        
End If

OpErr:
'OpCode error.
If OpcodeError Then Debug.Print "Opcode error"

If OpcodeError And Rescan = 1 Then Form1.ErrLog.text = Form1.ErrLog.text & "OpCode error : " & Fnc1 & " " & Fnc2 & " (line " & NbLine + 1 & ")" & vbCrLf


Nxt_line:
NbLine = NbLine + 1

Loop ' Loop Line reading

ASMcnt = 0: NbLine = 0

Next Rescan

For Ca = 0 To UBound(Equ_val)
    If Equ_word(Ca) <> "" Then
        Form1.ListView2.ListItems.Add Ca + 1, , Equ_word(Ca)
        Form1.ListView2.ListItems.Item(Form1.ListView2.ListItems.Count).SubItems(1) = Equ_val(Ca)
    End If
Next

For Ca = 0 To UBound(Equ_Assigned)
If Equ_Assigned(Ca) = False And Equ_word(Ca) <> "" Then Form1.ErrLog.text = Form1.ErrLog.text & "Label '" & Equ_word(Ca) & "' Not defined." & vbCrLf
Next

hFile_PRT = FreeFile
If Dir(App_path & "\Asm_Debug.bin") <> "" Then Kill App_path & "\Asm_Debug.bin"
Open App_path & "\Asm_Debug.bin" For Binary As hFile_PRT
Put #hFile_PRT, 1, AsmBuffer
Close hFile_PRT

Form1.ErrLog.text = Form1.ErrLog.text & "*** Code compiled. ***" & vbCrLf
Exit Sub

Main_Err:
Form1.ErrLog.text = Form1.ErrLog.text & "Main compiler jam: Can't do that !"
End Sub

Function Remove_Spaces(sText As String) As String
Dim TmpTXT As String
Dim FrstChr As String * 1
TmpTXT = ""

Do
FrstChr = sText
If FrstChr <> " " And FrstChr <> vbTab Then TmpTXT = TmpTXT & FrstChr
If sText = "" Then Exit Do
sText = Right(sText, Len(sText) - 1)
Loop
Remove_Spaces = TmpTXT
End Function


Function Unstring(TxtStr As String, datas() As Byte) As Integer
If TxtStr = "" Then Unstring = -1: Exit Function
' Convert a string : "1 2 3" to a bytes array values.
'  Datas(0)=1 , Datas(1)=2 and Datas(2)=3.
Dim tmpStr As String
Dim cmp As Integer, StrCmp As Integer

cmp = 0
On Error Resume Next
TxtStr = TxtStr & "|"

Do

If InStr(1, TxtStr, " ") = 0 Then
tmpStr = Left(TxtStr, InStr(1, TxtStr, "|") - 1)
TxtStr = "|"
Else
tmpStr = Left(TxtStr, InStr(1, TxtStr, " ") - 1)
TxtStr = Trim(Right(TxtStr, Len(TxtStr) - Len(tmpStr) - 1))
End If

ReDim Preserve datas(cmp)
If InStr(1, tmpStr, "+") > 0 Then
    'decimal values.
    datas(cmp) = Val16(Right(tmpStr, Len(tmpStr) - 1))
Else
    If InStr(1, tmpStr, Chr(&H22)) > 0 Or InStr(1, tmpStr, "'") > 0 Then ' ...'"' ist's a ZxChar. code.
        
        For StrCmp = 2 To Len(tmpStr) - 1
        ReDim Preserve datas(cmp)
        datas(cmp) = ASCIICharToZX(Mid(tmpStr, StrCmp, 1))
        If Mid(tmpStr, StrCmp + 1, 1) = Chr(&H22) Then Exit For
        cmp = cmp + 1
        Next StrCmp
    Else
        'Hexa Values.
        datas(cmp) = Val16("&h" & Trim(tmpStr))
    End If
End If
If TxtStr = "|" Then Exit Do
cmp = cmp + 1
Loop

Unstring = cmp

End Function

Function ASChex(Strhex As String) As Single
If Len(Strhex) >= 8 Then ASChex = 65535: Exit Function

Dim multi As String
Dim a As Integer
multi = 0
ASChex = 0
If Strhex = "" Then Exit Function

For a = Len(Strhex) To 1 Step -1
ASChex = ASChex + (CSng(Val16("&h" & Mid(Strhex, a, 1))) * CSng((16 ^ multi)))
multi = multi + 1
Next

End Function

Public Function ASCIICharToZX(ByVal cZX As String, Optional Func As Boolean = True, Optional bCase As Boolean = False) As Byte
    If cZX = "" Or cZX = Chr(224) Or cZX = Chr(255) Then ASCIICharToZX = 143: Exit Function
    
' Convert PC Codes to ZX characters codes.
'  Pc Display to Zx81 Memory.
    
    Dim cZX_Asc As Byte
    cZX_Asc = Asc(cZX)
    
    Select Case cZX_Asc
    Case &H30 To &H39
        ASCIICharToZX = cZX_Asc - 20: Exit Function
        
    Case &H41 To &H5A
        ASCIICharToZX = cZX_Asc - 27: Exit Function
        
    Case &H61 To &H7A
        ASCIICharToZX = cZX_Asc + 69: Exit Function
        
    Case Asc(&HD) ' , Asc(&HA)  '"N/L" vbCrLf
        ASCIICharToZX = 118: Exit Function

    Case Asc(" ") ' // SPACE
        ASCIICharToZX = 0: Exit Function
    Case 34 To 36
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ASCIICharToZX = cZX_Asc - 23: Exit Function
    Case Asc(":")
        ' 14 = :
        ASCIICharToZX = 14: Exit Function
    Case Asc("?")
        ' 15 = ?
        ASCIICharToZX = 15: Exit Function
    Case Asc("(")
        ' 16 = (
        ASCIICharToZX = 16: Exit Function
    Case Asc(")")
        ' 17 = )
        ASCIICharToZX = 17: Exit Function
    Case Asc(">")
        ' 18 = >
        ASCIICharToZX = 18: Exit Function
    Case Asc("<")
        ' 19 = <
        ASCIICharToZX = 19: Exit Function
    Case Asc("=")
        ' 20 = =
        ASCIICharToZX = 20: Exit Function
    Case Asc("+")
        ' 21 = +
        ASCIICharToZX = 21: Exit Function
    Case Asc("-")
        ' 22 = -
        ASCIICharToZX = 22: Exit Function
    Case Asc("*")
        ' 23 = *
        ASCIICharToZX = 23: Exit Function
    Case Asc("/")
        ' 24 = /
        ASCIICharToZX = 24: Exit Function
    Case Asc(";")
        ' 25 = ;
        ASCIICharToZX = 25: Exit Function
    Case Asc(",")
         ' 26 = ,
        ASCIICharToZX = 26: Exit Function
    Case Asc(".")
        ' 27 = .
        ASCIICharToZX = 27: Exit Function
        
        
  ' ZxDraw ASCII chars.
  
  'Invert chars
  Case &H86 To &HA0
      'Debug.Print ZXCharToASCII(cZX_Asc + 5)
  ASCIICharToZX = cZX_Asc + 5: Exit Function
  
  Case &HA3
  ASCIICharToZX = 12: Exit Function
  
  '  "\" + Chr(&H22)+ Chr(&H22)
  Case &HC0
  ASCIICharToZX = 192: Exit Function
  
  '  "\' "
  Case &HB6
  ASCIICharToZX = 1: Exit Function
  
  '  "\ '"
    Case &HB7
  ASCIICharToZX = 2: Exit Function
    
  '  "\''"
   Case &HB8
  ASCIICharToZX = 3: Exit Function

  '  "\. "
  
  Case &HB9
  ASCIICharToZX = 4: Exit Function

  '  "\: "
  Case &HBA
  ASCIICharToZX = 5: Exit Function

  '  "\.'"
  Case &HBB
  ASCIICharToZX = 6: Exit Function

  '  "\:'"
  Case &HBC
  ASCIICharToZX = 7: Exit Function

  '  "\##"
  Case &HBD
  ASCIICharToZX = 8: Exit Function

  '  "\,,"
  Case &HBE
  ASCIICharToZX = 9: Exit Function

  '  "\~~"
  Case &HBF
  ASCIICharToZX = 10: Exit Function

  '  "\::"
  Case &HAB
  ASCIICharToZX = &H80: Exit Function

  '  "\.:"
  Case &HAC
  ASCIICharToZX = &H81: Exit Function

  '  "\:."
  Case &HAD, &HAA
  ASCIICharToZX = &H82: Exit Function

  '  "\.."
  Case &HAE
  ASCIICharToZX = &H83: Exit Function

  '  "\':"
  Case &HAF
  ASCIICharToZX = &H84: Exit Function
  
   '  "\ :"
  Case &HB0
  ASCIICharToZX = &H85: Exit Function

  '  "\'."
  Case &HB1
  ASCIICharToZX = &H86: Exit Function

   '  "\ ."
  Case &HB2
  ASCIICharToZX = &H87: Exit Function

   '  "\@@"
  Case &HB3
  ASCIICharToZX = &H88: Exit Function

  '  "\;;"
  Case &HB4
  ASCIICharToZX = &H89: Exit Function

  '  "\!!"
  Case &HB5
  ASCIICharToZX = &H8A: Exit Function

    Case Else
    
        ' While Ascii scan, don't bother the "[" symbol. (The next Char. scan in variables names)
      If cZX <> "[" And cZX <> "\" And cZX <> "%" Then
      'Disp_Err 4
      End If
      ASCIICharToZX = 143
    End Select
End Function

Function Hex8(Value As Long) As String
If Value >= &H100 Then Hex8 = "FF": Exit Function
If Value < &H10 Then
Hex8 = "0" & Hex(Value)
Else
Hex8 = Hex(Value)
End If

End Function

Function Hex16(Value As Long) As String
If Value >= &H10000 Then Hex16 = "FFFF": Exit Function
If Value < &H10 Then
   Hex16 = "000" & Hex(Value): Exit Function
ElseIf Value < &H100 Then
   Hex16 = "00" & Hex(Value): Exit Function
ElseIf Value < &H1000 Then
   Hex16 = "0" & Hex(Value): Exit Function
End If
Hex16 = Hex8(Value \ &H100) & Hex8(Value - (Value \ &H100) * &H100)
End Function

Function GetVal(Value As String) As Long
Dim a As Integer
Dim Value2 As String


If InStr(1, Value, ";") <> 0 Then Value = Trim(Left(Value, InStr(1, Value, ";") - 1))
Value2 = UCase(Value)

If IsDecValue(Value) Then
        If Val(Value) < 0 Then
        GetVal = Val(Value)
        Exit Function
        End If
End If


For a = 1 To Len(Value)

If Mid(Value, a, 1) = "$" Or Mid(Value, a, 1) = "H" Then
    If UCase(Left(Value, 2) = "&H") Then
        Value2 = Left(Value, a - 1) & "&H" & Mid(Value, a + 1)
    Else
        Value2 = "&H" & Left(Value, a - 1) & "&H" & Mid(Value, a + 1)
    End If
End If

Next a

If Left(Value2, 4) = "&H&H" Then Value2 = Mid(Value2, 3)
If Right(Value2, 2) = "&H" Then Value2 = Left(Value2, Len(Value2) - 2)

GetVal = CLng(Val16(Value2))

If GetVal < 0 Then GetVal = 65536 + GetVal



End Function


Function GetAsmCodes(Fnc1 As String, Fnc2 As String, Optional Nb_Op As Integer) As OpArg

Dim Cnt As Integer, Cnt2 As Integer
Dim OpOtr As String
OpcodeError = True

If Fnc2 = Trim("") Then Fnc2 = Chr(&H22) & Chr(&H22)

OpOtr = Trim(Fnc1)

For Cnt = 0 To 787:
If OpOtr = Trim(OpArg(Cnt).InStr) Then Exit For
Next: If Cnt = 788 Then GoTo OPerror

 Cnt2 = Cnt - 1
 
Do
Cnt2 = Cnt2 + 1
If Cnt2 = 788 Then GoTo OPerror
Loop While Trim(OpArg(Cnt2).ARGS) <> Fnc2

If Cnt2 < 788 Then Cnt = Cnt2

' InStr As String * 5
' ARGS As String * 7
' OP1 As Byte
' OP2 As Byte
' BYTES As Byte
' RULE As String * 4
' Class As Byte
' SHIFT As Boolean
' OR1 As Byte
' OR2 As Byte

'Debug.Print OpArg(Cnt).InStr & "~" & OpArg(Cnt).ARGS & "~" & _
'Hex(OpArg(Cnt).OP1) & "~" & Hex(OpArg(Cnt).OP2) & "~" & OpArg(Cnt).BYTES & "~" & _
'OpArg(Cnt).BYTES & "~" & OpArg(Cnt).RULE & "~" & OpArg(Cnt).Class & "~" & _
'OpArg(Cnt).SHIFT & "~" & Hex(OpArg(Cnt).OR1) & "~" & Hex(OpArg(Cnt).OR2) & "~" & _
'OpArg(Cnt).NBOp

GetAsmCodes = OpArg(Cnt)
OpcodeError = False
Exit Function

OPerror:

End Function

Function IsReg(MyStr As String) As Byte

IsReg = 0
Select Case MyStr
    Case "A", "B", "C", "D", "E", "F", "H", "L", "I", "R"
    IsReg = 1
    Case "AF", "BC", "HL", "DE", "SP", "IX", "IY", "AF'"
    IsReg = 2
    Case "(AF)", "(BC)", "(HL)", "(DE)", "(SP)", "(IX)", "(IY)"
    IsReg = 3
    Case "(C)"
    IsReg = 4
    Case "C", "M", "NC", "NZ", "P", "PE", "PO", "Z"
    IsReg = 5
     Case "*", "(*)"
    IsReg = 6
     Case "(IX*)", "(IY*)"
    IsReg = 7
   
End Select
End Function

Function IsLabel(MyLabel As String) As Integer
Dim Cnt As Integer
Dim TmpLabel As String

IsLabel = -1

MyLabel = Trim(MyLabel)
If MyLabel = "" Or InStr(1, UCase(MyLabel), "&H") > 0 Then Exit Function

If InStr(1, MyLabel, """") = 0 And InStr(1, MyLabel, "'") = 0 Then MyLabel = UCase(MyLabel)

For Cnt = 0 To UBound(Equ_word)
If InStr(1, MyLabel, """") = 0 And InStr(1, MyLabel, "'") = 0 Then TmpLabel = UCase(Equ_word(Cnt)) Else TmpLabel = Equ_word(Cnt)
If TmpLabel = MyLabel Then IsLabel = Cnt: Exit For
Next Cnt
End Function

Function IsDecValue(text As String) As Boolean
Dim FrstChr As String * 1
Dim TstCHR As Byte
Dim TmpTXT As String

TmpTXT = UCase(text)
IsDecValue = True

Do
FrstChr = TmpTXT
TstCHR = CByte(Asc(FrstChr))

If Not (TstCHR > &H2F And TstCHR < &H3A) And TstCHR <> 45 Then IsDecValue = False: Exit Function
TmpTXT = Right(TmpTXT, Len(TmpTXT) - 1)
If TmpTXT = "" Then Exit Do
Loop
End Function

Function IsHexValue(text As String) As Boolean
Dim FrstChr As String * 1
Dim TstCHR As Byte
Dim TmpTXT As String

TmpTXT = UCase(text)
IsHexValue = True

Do
FrstChr = TmpTXT
TstCHR = CByte(Asc(FrstChr))

If Not (TstCHR > &H40 And TstCHR < &H47) _
And Not (TstCHR > &H2F And TstCHR < &H3A) Then IsHexValue = False: Exit Function
TmpTXT = Right(TmpTXT, Len(TmpTXT) - 1)
If TmpTXT = "" Then Exit Do
Loop
End Function

Private Sub AddLabel(Label As String)
If InStr(1, UCase(Label), "&H") > 0 Or Label = "" Then Exit Sub

If InStr(1, Label, "$") > 0 And (InStr(1, Label, """") > 0 Or InStr(1, Label, "'") > 0) Then Exit Sub


Dim sFrstChr  As String * 1
Dim Label2  As String
Dim CharVal As Long
On Error GoTo Err_AddLabel

Label = Trim(Remove_Spaces(Label))

If (IsHexValue(Label) Or IsDecValue(Label)) And Rescan = 1 Then
        If IsHexValue(Label) Then
        Form1.ErrLog.text = Form1.ErrLog.text & "Value error: Hexadecimal without '$' char. [" & Label & "]" & vbCrLf
        Else
        Form1.ErrLog.text = Form1.ErrLog.text & "Value error: Decimal value error [" & Label & "]" & vbCrLf
        End If
End If

If IsLabel(Label) = -1 And Label <> "" Then

    Label2 = Label
    sFrstChr = Label2
        
    If sFrstChr = Chr(34) Or sFrstChr = "'" Then
          
        Label2 = Right(Label2, Len(Label2) - 1)
        If Label2 <> "" Then Label2 = Left(Label2, Len(Label2) - 1)
        
        If InStr(1, Label2, "_") > 1 Or InStr(1, Label2, "\") > 1 Then
            If InStr(1, Label2, "_") > 1 Then Mid(Label2, InStr(1, Label2, "_"), 1) = " "
            If InStr(1, Label2, "\") > 1 Then Mid(Label2, InStr(1, Label2, "\"), 1) = " "
        Label2 = LCase(Label2)
        End If
        If Label2 <> "" Then
        If sFrstChr <> Chr(34) Then
         CharVal = ASCIICharToZX(Label2)
        Else
         CharVal = Asc(Label2)
        End If
        End If
    End If


            ReDim Preserve Equ_word(iLabelID)
            ReDim Preserve Equ_val(iLabelID)
            ReDim Preserve Equ_Assigned(iLabelID)
            
            Equ_word(iLabelID) = Label
            Equ_val(iLabelID) = -1
            Equ_Assigned(iLabelID) = False
            
            If sFrstChr = Chr(34) Or sFrstChr = "'" Then
             Equ_val(iLabelID) = CharVal
             Equ_Assigned(iLabelID) = True
            End If
            
            iLabelID = iLabelID + 1
End If
Exit Sub
Err_AddLabel:
If Rescan = 1 Then Form1.ErrLog.text = Form1.ErrLog.text & "Bad character value (PC/ZX): " & Label & vbCrLf
End Sub

Function Cut_Alfa_Label(Label As String) As String

Dim Cnt As Integer
Dim TstCHR As Byte
Dim TmpLabel As String

TmpLabel = ""
Cnt = 0


Do
Cnt = Cnt + 1
If Cnt > Len(Label) Then Exit Do
TstCHR = Asc(Mid(Label, Cnt, 1))
If (TstCHR > &H40 And TstCHR < &H5B) Or (TstCHR > &H2F And TstCHR < &H3A) Or TstCHR = Asc("_") Then TmpLabel = TmpLabel + Chr(TstCHR) Else Exit Do
Loop

Cut_Alfa_Label = TmpLabel


End Function

Function Enum_Exp(sMyText As String) As String


On Error GoTo Err_Exp

Dim TmpText As String
Dim a As Integer
Dim MyChar As String * 1
Dim EnuLabels() As String
Dim IdLabels As Integer
Dim MyVal As Long
Dim sText As String

sText = sMyText

If UCase(sText) = "LB4082" Then
Debug.Print
End If

If IsReg(sText) > 0 Or Trim(sText) = "" Then Exit Function

TmpText = ""
IdLabels = 0
Enum_Exp = ""

For a = 1 To Len(sText)
  MyChar = Mid(sText, a)
  
        If MyChar <> "+" And MyChar <> "-" And MyChar <> "*" And MyChar <> "/" And a < Len(sText) Then
        
            If MyChar = "$" Then TmpText = TmpText + "&h" Else TmpText = TmpText + MyChar
        
        Else
         If a = Len(sText) Then TmpText = TmpText + MyChar
         
         'If a = Len(sText) Then MyChar = Mid(sText, a + 1)
         If MyChar = "+" Or MyChar = "-" Or MyChar = "*" Or MyChar = "/" Or a = Len(sText) Then
                    
                    If TmpText = "&h" Then
                    TmpText = TmpText + Hex16(Org_ASM + ASMcnt)
                    End If
            
                    If a = Len(sText) Then MyChar = ""
                    If IsLabel(TmpText) > -1 Then
                       ReDim Preserve EnuLabels(IdLabels + 1)
                       Debug.Print TmpText
                       EnuLabels(IdLabels) = Equ_val(IsLabel(TmpText))
                       EnuLabels(IdLabels + 1) = MyChar
                       IdLabels = IdLabels + 2
                       TmpText = ""
                    Else
                       ReDim Preserve EnuLabels(IdLabels + 1)
                       EnuLabels(IdLabels) = TmpText
                       If a < Len(sText) Then EnuLabels(IdLabels + 1) = MyChar
                       IdLabels = IdLabels + 2
                       TmpText = ""
                    End If

          End If
        End If
Next a

MyVal = 0

            MyVal = Val16(EnuLabels(0))
            
            If IdLabels = 2 Then
                Enum_Exp = CStr(MyVal)
                Exit Function
            End If
            
                  
            For a = 1 To IdLabels - 2 Step 2
                Select Case EnuLabels(a)
                Case "+"
                 MyVal = MyVal + EnuLabels(a + 1)
                 Debug.Print EnuLabels(a) & EnuLabels(a + 1);
                Case "-"
                    If EnuLabels(a + 1) < 0 Then
                     MyVal = MyVal + EnuLabels(a + 1)
                 Debug.Print EnuLabels(a) & EnuLabels(a + 1);
                    Else
                     MyVal = MyVal - EnuLabels(a + 1)
                 Debug.Print EnuLabels(a) & EnuLabels(a + 1);
                    End If
                Case "/"
                  MyVal = MyVal / EnuLabels(a + 1)
                 Debug.Print EnuLabels(a) & EnuLabels(a + 1);
                Case "*"
                  MyVal = MyVal / EnuLabels(a + 1)
                 Debug.Print EnuLabels(a) & EnuLabels(a + 1);
                End Select
 
            Next a
                 Debug.Print
            Enum_Exp = CStr(MyVal)
            
            Exit Function
            
Err_Exp:

 If Rescan = 1 Then Form1!ErrLog.text = Form1!ErrLog.text & "Illegal expression : " & sText & vbCrLf '  "Line " & NbLine
 
End Function

Function IsExp(sText As String) As Boolean

Dim a As Integer
Dim MyChar As String * 1

IsExp = False

For a = 1 To Len(sText)
  MyChar = Mid(sText, a)
  
        If MyChar = "+" Or MyChar = "-" Or MyChar = "*" Or MyChar = "/" Then
        IsExp = True
        Exit For
        End If
Next a


End Function

Function IsAssNum(Value As String) As Boolean
Dim a As Integer
Dim Value2 As String
IsAssNum = True
Value2 = Trim(UCase(Value))
For a = 1 To Len(Value)
If Asc(Mid(Value2, a, 1)) > &H46 And Asc(Mid(Value2, a, 1)) < &H5B And Mid(Value2, a, 1) <> "H" Then IsAssNum = False
Next
End Function

Function IsBinary(Value As String) As Boolean
Dim a As Integer
Dim Value2 As String
IsBinary = True
Value2 = Trim(UCase(Value))
For a = 1 To Len(Value)
If Mid(Value2, a, 1) <> "1" And Mid(Value2, a, 1) <> "0" And Mid(Value2, a, 1) <> "B" And Mid(Value2, a, 1) <> "%" Then IsBinary = False
Next
End Function


Function BinToDbl(Value As String) As Long
    'Convertir chane binaire en entier
    '  Value$ - chane binaire , par exemple "0110101"
    '  Dez#   - Entier
    Dim Dezimal As Double
    Dim MaxLen As Integer
    Dim b As Integer, X As Integer
  
    MaxLen = Len(Value)
    For X = 1 To MaxLen
    If Trim(Mid$(Value, X, 1)) <> "B" And Trim(Mid$(Value, X, 1)) <> "%" Then
        b = Val16(Mid$(Value, X, 1))
        Dezimal = Dezimal + b * 2 ^ (MaxLen - X)
    End If
    Next
    BinToDbl = CLng(Dezimal)
End Function

Function Val16(txtVal As String) As Long
Val16 = Val(txtVal & "&")
End Function

Function Remove_Tabs(sMyText As String) As String
Dim TmpTXT As String
Dim FrstChr As String * 1
Dim sText As String

TmpTXT = ""

sText = sMyText

Do
FrstChr = sText
If FrstChr <> vbTab Then TmpTXT = TmpTXT & FrstChr Else TmpTXT = TmpTXT & " "
If sText = "" Then Exit Do
sText = Right(sText, Len(sText) - 1)
Loop
Remove_Tabs = TmpTXT

End Function

